poj 3498 March of the Penguins 点流量有限制的最大流

题意:

给n块浮冰的坐标,每块浮冰上的企鹅数和能承受跳起的次数,求有哪些浮冰能让企鹅能到一起。

分析:

拆点将点流量的限制转化为边流量的限制,求最大流。

代码:

//poj 3498
//sep9
#include <iostream>
#include <queue>
#include <algorithm>
#include <cmath>
using namespace std;
const int maxN=128;
const int maxM=40;
const int maxV=260;
const int maxE=26000;
struct Edge
{
	int u,v,f,nxt;
}e[maxE*2+10];
queue<int> que;
int src,sink;
int g[maxV+10];
int nume;
bool vis[maxV+10];
int dist[maxV+10];

double x[maxN],y[maxN];
int num[maxN],m[maxN];

void addedge(int u,int v,int c)
{
	e[nume].u=u,e[nume].v=v;e[nume].f=c;e[nume].nxt=g[u];g[u]=nume++;
	e[nume].u=v;e[nume].v=u;e[nume].f=0;e[nume].nxt=g[v];g[v]=nume++;
}
void init()
{
	memset(g,0,sizeof(g));
	nume=2;
}

int bfs()
{
	while(!que.empty()) que.pop();
	memset(dist,0,sizeof(dist));
	memset(vis,0,sizeof(vis));
	vis[src]=true;
	que.push(src);
	while(!que.empty()){
		int u=que.front();que.pop();
		for(int i=g[u];i;i=e[i].nxt)
			if(e[i].f&&!vis[e[i].v]){
				que.push(e[i].v);
				dist[e[i].v]=dist[u]+1;
				vis[e[i].v]=true;
				if(e[i].v==sink)
					return 1;
			}
	}
	return 0;
}

int dfs(int u,int delta)
{
	if(u==sink)
		return delta;
	int ret=0;
	for(int i=g[u];ret<delta&&i;i=e[i].nxt)
		if(e[i].f&&dist[e[i].v]==dist[u]+1){
			int dd=dfs(e[i].v,min(e[i].f,delta-ret));
			if(dd>0){
				e[i].f-=dd;
				e[i^1].f+=dd;
				ret+=dd;
			}
			else
				dist[e[i].v]=-1;
		}
	return ret;
}

int dinic()
{
	int ret=0;
	while(bfs()==1)
		ret+=dfs(src,INT_MAX);
	return ret;
}
void solve()
{
	int i,j,t,n,sum;
	double D;
	scanf("%d%lf",&n,&D);
	sum=0,src=2*n;
	int ok=0;
	for(i=0;i<n;++i){
		scanf("%lf%lf%d%d",&x[i],&y[i],&num[i],&m[i]);
		sum+=num[i];
	}
	for(t=0;t<n;++t){
		init();
		for(i=0;i<n;++i){
			addedge(src,i,num[i]);
			addedge(i,i+n,m[i]);
		}
		for(i=0;i<n;++i)
			for(j=0;j<n;++j)
				if(i!=j){
					double L=sqrt((x[i]-x[j])*(x[i]-x[j])+(y[i]-y[j])*(y[i]-y[j]));
					if(L<D||fabs(L-D)<1e-6){
						addedge(i+n,j,INT_MAX);
					}
				}
		sink=t;
		if(dinic()==sum){
			printf("%d ",t);
			ok=1;
		}
	}
	if(!ok)
		printf("-1");
	printf("\n");
}

int main()
{
	int cases;
	scanf("%d",&cases);
	while(cases--)
		solve();
	return 0;
}  
时间: 2024-10-23 17:39:53

poj 3498 March of the Penguins 点流量有限制的最大流的相关文章

POJ 3498 March of the Penguins(网络流+枚举)

题目链接:http://poj.org/problem?id=3498 题目: Description Somewhere near the south pole, a number of penguins are standing on a number of ice floes. Being social animals, the penguins would like to get together, all on the same floe. The penguins do not wa

[POJ 3498] March of the Penguins

March of the Penguins Time Limit: 8000MS   Memory Limit: 65536K Total Submissions: 4378   Accepted: 1988 Description Somewhere near the south pole, a number of penguins are standing on a number of ice floes. Being social animals, the penguins would l

uva 12125 March of the Penguins (最大流)

uva 12125 March of the Penguins 题目大意:网格上有n(n<=100)片荷叶,初始时第i片荷叶上有ni只企鹅(0<=ni<=10).由于承受能力有限,第i片荷叶最多只能承受mi(1<=mi<=200)只企鹅从上米娜跳走.一只企鹅最多能跳D(D<=105)单位距离.要求所有企鹅在同一片荷叶上集合.问哪些荷叶可以成为企鹅们集合的地点. 解题思路:企鹅为什么不游泳--.每片荷叶是有容量的,所以每片荷叶都要进行拆点,拆成两个点,容量为这片荷叶所能承

poj 3498 最大流

March of the Penguins Time Limit: 8000MS   Memory Limit: 65536K Total Submissions: 4809   Accepted: 2195 Description Somewhere near the south pole, a number of penguins are standing on a number of ice floes. Being social animals, the penguins would l

UVA 12125 - March of the Penguins(最大流)

UVA 12125 - March of the Penguins 题目链接 题意:给定一些冰块,每个冰块上有一些企鹅,每个冰块有一个可以跳出的次数限制,每个冰块位于一个坐标,现在每个企鹅跳跃力为d,问所有企鹅能否跳到一点上,如果可以输出所有落脚冰块,如果没有方案就打印-1 思路:最大流,拆点表示冰块次数限制,然后枚举落脚冰块建图跑最大流即可 代码: #include <cstdio> #include <cstring> #include <queue> #inclu

POJ 2135 Farm Tour &amp;&amp; HDU 2686 Matrix &amp;&amp; HDU 3376 Matrix Again 费用流求来回最短路

累了就要写题解,最近总是被虐到没脾气. 来回最短路问题貌似也可以用DP来搞,不过拿费用流还是很方便的. 可以转化成求满流为2 的最小花费.一般做法为拆点,对于 i 拆为2*i 和 2*i+1,然后连一条流量为1(花费根据题意来定) 的边来控制每个点只能通过一次. 额外添加source和sink来控制满流为2. 代码都雷同,以HDU3376为例. #include <algorithm> #include <iostream> #include <cstring> #in

March of the Penguins

poj3498:http://poj.org/problem?id=3498 题意:某个冰块上有a只企鹅,总共可以跳出去b只,问是否可能所有的企鹅都跳到某一块冰块上,输出所有的可能的冰块的编号. 由于每个点只能跳出去m只企鹅,所以要拆点假如不拆点,一个点到另一个点可能会跳多于m只企鹅通过拆点后u->u'间的容量来完成题目的要求(对点的一些限制) 建图:i->i+n 容量为m i+n->j容量为INF新建源点s,s->i的容量为i点企鹅的个数然后枚举汇点求最大流就可以判断某个点是否符

【POJ3498】March of the Penguins(最大流,裂点)

题意:在靠近南极的某处,一些企鹅站在许多漂浮的冰块上.由于企鹅是群居动物,所以它们想要聚集到一起,在同一个冰块上.企鹅们不想把自己的身体弄湿,所以它们在冰块之间跳跃,但是它们的跳跃距离,有一个上限. 随着气温的升高,冰块开始融化,并出现了裂痕.而企鹅跳跃的压力,使得冰块的破裂加速.幸运的是,企鹅对冰块十分有研究,它们能知道每块冰块最多能承受多少次跳跃.对冰块的损害只在跳起的时候产生,而落地时并不对其产生伤害. 现在让你来帮助企鹅选择一个冰面使得它们可以聚集到一起. 第一行整数N,和浮点数D,表示

hdu 2334 March of the Penguins

  题意大意 在X,Y坐标系中有N(N<=100)个冰块,有些冰块上有1若干只企鹅,每只企鹅一次最多跳M距离,一个冰块在有Mi个企鹅离开,就会消失,问有哪些冰块可以作为集合点,就是所有企鹅都能成功到这个冰块上来 题目分析  枚举点作为结束点,由于每个点有出企鹅的限制,用拆点来解决,一个点拆成"起点"和"终点",“起点"到"终点"的流量为最大离开企鹅数,而超级源点与每个点的"起点"做边,容量为其企鹅的数量,再根据